src/Entity/FormIO.php
<?php

namespace App\Entity;

use App\Form\Admin\Servizio\PaymentDataType;
use Doctrine\ORM\Mapping as ORM;

/**
 * Class FormIO
 * @ORM\Entity
 */
class FormIO extends Pratica implements DematerializedFormPratica
{
  public const FIELD_SUBJECT = 'application_subject';


  public function __construct()
  {
    parent::__construct();
    $this->type = self::TYPE_FORMIO;
    $this->dematerializedForms = [];
  }

  public function getPaymentAmount()
  {
    $formAmount = $this->getFormPaymentAmount();
    if ($formAmount !== null) {
      return $formAmount;
    }

    $serviceAmount = $this->getServicePaymentAmount();
    if ($serviceAmount !== null) {
      return $serviceAmount;
    }

    return 0;
  }

  public function getFormPaymentAmount(): ?float
  {
    $formAmount = $this->dematerializedForms['flattened'][PaymentDataType::PAYMENT_AMOUNT] ?? null;
    return $formAmount ? (float)str_replace(',', '.', $formAmount) : null;
  }

  private function getServicePaymentAmount(): ?float
  {
    $serviceAmount = $this->getServizio()->getPaymentParameters()['total_amounts'] ?? null;
    return $serviceAmount ? (float)str_replace(',', '.', $serviceAmount) : null;
  }

  public function setPaymentAmount($amount): void
  {
    $dematerializedForms = $this->dematerializedForms;
    $dematerializedForms['data'][PaymentDataType::PAYMENT_AMOUNT] = $amount;
    $dematerializedForms['flattened'][PaymentDataType::PAYMENT_AMOUNT] = $amount;
    $this->dematerializedForms = $dematerializedForms;
  }

  public function isPaymentExempt(): bool
  {
    $data = $this->dematerializedForms;
    return isset($data['flattened'][PaymentDataType::PAYMENT_AMOUNT]) && $data['flattened'][PaymentDataType::PAYMENT_AMOUNT] <= 0;
  }

  public function hasImmediatePayment(): bool
  {
    return $this->getPaymentAmount() || $this->getServizio()->isPaymentRequired();
  }

  public function hasPaymentDeferred(): bool
  {
    $paymentData = $this->getPaymentData();
    return ($this->getPaymentAmount() > 0 && !empty($paymentData['deferred'])) || (!empty($paymentData['deferred']) && !empty($paymentData['amount']));
  }

  public function getType(): string
  {
    return Pratica::TYPE_FORMIO;
  }

  public function generateSubject(): string
  {
    $data = $this->dematerializedForms;
    if (isset($data['flattened'][self::FIELD_SUBJECT]) && !empty($data['flattened'][self::FIELD_SUBJECT])) {
      return $data['flattened'][self::FIELD_SUBJECT];
    }
    return parent::generateSubject();
  }

}

templates/Pratiche/parts/landing/_f24.html.twig
{% block main_content %}
  <div class="cmp-heading pb-3 pb-lg-4" >
    {# In attesa di generazione del pdf #}
    {% if pratica.status == 1900 %}
      <div class="categoryicon-top d-flex" id="container-f24" data-url="{{ path('application_api_get',{'id': pratica.id}) }}">
        <svg class="icon icon-success mr-10 big-lg-icon mb-1" aria-hidden="true">
          <use href="/bootstrap-italia/dist/svg/sprite.svg#it-check-circle"></use>
        </svg>
        <h1 class="title-xxxlarge">{{ 'pratica.f24_sent' | trans }}</h1>
      </div>
      <p class="my-2">
        {{ 'operatori.attesa_modello_f24_info'|trans|raw }}
      </p>
      <div class="alert alert-warning alert-error d-none" role="alert"></div>
      <button disabled type="button" class="btn btn-secondary btn-xs disabled fw-bold mb-2 d-flex align-items-center px-1 justify-content-center btn-f24-loader">
        <div class="progress-spinner progress-spinner-double size-sm progress-spinner-active">
          <div class="progress-spinner-inner"></div>
          <div class="progress-spinner-inner"></div>
        </div>
        <div class="px-2"><span>  {{ 'operatori.attesa_modulo_compilato_pdf'|trans|raw }}</span></div>
      </button>
      {# Pratica inviata #}
    {% elseif pratica.status == 2000 %}
      <div class="container">
        <div class="row">
          <div class="cmp-heading pb-3 pb-lg-4">
            <div class="categoryicon-top d-flex">
              <svg class="icon icon-success mr-10 big-lg-icon mb-1" aria-hidden="true">
                <use href="{{ asset('bundles/app/images/sprites.svg') }}#it-check-circle"></use>
              </svg>
              <h1 class="title-xxxlarge">{{ 'pratica.f24_created' | trans }}</h1>
            </div>
            <p class="subtitle-small"> {{ 'pratica.thanks_message_f24'|trans({'%name%':pratica.servizio.name,'%id%':pratica.id})|raw }}</p>
            <p class="pt-3 pt-lg-4 mb-0">
            {{ 'pratica.to_email' | trans }} <strong>{{ pratica.user.email }}</strong> {{ 'pratica.sent_to_email_new' | trans }}
            </p>
            {% set attachment = pratica.moduliCompilati|first %}
            <a class="btn btn-outline-primary fw-bold"
               href="{{ path('allegati_download', {'allegato': attachment.id}) }}" download>
                  <span class="rounded-icon">
                    <svg class="icon icon-primary icon-sm" aria-hidden="true">
                      <use href="{{ asset('bundles/app/images/sprites.svg') }}#it-download"></use>
                    </svg>
                  </span>
              <span>{{ 'operatori.download.f24' | trans }}</span>
            </a>
          </div>
        </div>

        {% if is_granted('ROLE_USER') and not is_granted('ROLE_OPERATORE') %}
          <p class="mt-4 mt-lg-3 mb-40 mb-lg-100">
            <a class="t-primary" href="{{ app.request.uri ~ '/detail' }}">{{ 'pratica.consulta_dati' | trans }}</a>
            {{ 'pratica.nella_tua_area_riservata' | trans }}.
          </p>
        {% endif %}
      </div>
    {% else %}
      {% set attachment = pratica.moduliCompilati|first %}
      <a class="btn btn-outline-primary fw-bold mt-3"
         href="{{ path('allegati_download', {'allegato': attachment.id}) }}" download>
                  <span class="rounded-icon">
                    <svg class="icon icon-primary icon-sm" aria-hidden="true">
                      <use href="/bootstrap-italia/dist/svg/sprite.svg#it-download"></use>
                    </svg>
                  </span>
        <span>{{ 'operatori.scarica_richiesta_protocollata'|trans }}</span>
      </a>
    {% endif %}
  </div>
{% endblock %}

templates/Pratiche/parts/landing/_general.html.twig
<div class="cmp-heading pb-3 pb-lg-4">

  <div class="categoryicon-top d-flex">
    <svg class="icon icon-success mr-10 big-lg-icon mb-1" aria-hidden="true">
      <use href="/bootstrap-italia/dist/svg/sprite.svg#it-check-circle"></use>
    </svg>
    <h1 class="title-xxxlarge">{{ 'pratica.application_sent' | trans }}</h1>
  </div>
  <p class="subtitle-small">{{ 'pratica.thanks_message'|trans({'%name%':pratica.servizio.name,'%id%':pratica.id})|raw }}</p>

  {% if not pratica.servizio.disableMessageNotifications %}
    <p>{{ 'pratica.to_email' | trans }} <strong>{{ pratica.user.email }}</strong> {{ 'pratica.sent_to_email_new' | trans }}</p>
  {% endif %}
</div>

{{ include('Pratiche/parts/landing/_receipt.html.twig') }}

<p class="mt-4 mt-lg-3 mb-40 mb-lg-80">
    {{ 'pratica.sent_to_summary' | trans }}
  <a class="t-primary" href="{{ path('pratica_show_detail', {'pratica': pratica.id}) }}">{{ 'personal_area' | trans }}</a> {{ 'pratica.sent_to_summary_or' | trans({'%instance_url%': path('service_access', {'servizio': pratica.servizio.slug}),'%new_request%': 'new_request' | trans}) | raw }}
</p>

templates/Pratiche/parts/landing/_payment.html.twig
{% set paymentOutcome = app.request.query.get('payment_outcome') %}
<div class="cmp-heading pb-3 pb-lg-4">
  {% if (paymentOutcome | lower) == 'ko' %}
    <div class="categoryicon-top d-flex">
      <svg class="icon icon-danger mr-10 big-lg-icon mb-1" aria-hidden="true">
        <use href="/bootstrap-italia/dist/svg/sprite.svg#it-close-circle"></use>
      </svg>
      <h1 class="title-xxxlarge">{{ 'pratica.payment_error' | trans }}</h1>
    </div>
    <p class="subtitle-small">{{ 'pratica.payment_error_message'|trans({'%name%':pratica.servizio.name,'%id%':pratica.id})|raw }}</p>
    {% if payment %}
      <p class="text-small">
        {{ 'pratica.payment_error_detail_message'|trans({'%application_detail_url%': path('pratica_show_detail', {'pratica': pratica.id}), '%payment_detail_url%': path('payments_details_cpsuser', {'paymentId': payment.id})})|raw }}
      </p>
    {% endif %}
  {% else %}
    <div class="categoryicon-top d-flex">
      <svg class="icon icon-success mr-10 big-lg-icon mb-1" aria-hidden="true">
        <use href="/bootstrap-italia/dist/svg/sprite.svg#it-check-circle"></use>
      </svg>
      <h1 class="title-xxxlarge">
        {% if paymentOutcome %}{{ 'pratica.payment_success' | trans }}{% else %}{{ 'pratica.application_sent' | trans }}{% endif %}
      </h1>
    </div>
    <p class="subtitle-small">{{ 'pratica.thanks_message'|trans({'%name%':pratica.servizio.name,'%id%':pratica.id,'%ente%':pratica.ente.name})|raw }}</p>

    {% if not paymentOutcome %}
      <p>{{ 'pratica.payment_status_unknown' | trans }}</p>
    {% endif %}

    {% if not pratica.servizio.disableMessageNotifications %}
      <p>{{ 'pratica.to_email' | trans }} <strong>{{ pratica.user.email }}</strong> {{ 'pratica.sent_to_email_new' | trans }}</p>
    {% endif %}

    <p class="mt-4 mb-0">{{ 'payment.amount' | trans }}: <strong>{{ pratica.paymentAmount }} € {{ 'pratica.payment_transaction_label'|trans }}</strong></p>

    {{ include('Pratiche/parts/landing/_receipt.html.twig') }}

    <p class="mt-4 mt-lg-3 mb-40 mb-lg-80">
      {{ 'pratica.sent_to_summary_with_payment' | trans }}
      <a class="t-primary" href="{{ path('pratica_show_detail', {'pratica': pratica.id}) }}">{{ 'personal_area' | trans }}</a> {{ 'pratica.sent_to_summary_or' | trans({'%instance_url%': path('service_access', {'servizio': pratica.servizio.slug}),'%new_request%': 'new_request' | trans}) | raw }}
    </p>
  {% endif %}

</div>

templates/Pratiche/parts/landing/_payment_mypayV1.html.twig
{% set paymentOutcome = app.request.query.get('payment_outcome') %}
  {% if (paymentOutcome | lower) == 'ko' %}
    <div class="categoryicon-top d-flex">
      <svg class="icon icon-danger mr-10 big-lg-icon mb-1" aria-hidden="true">
        <use href="/bootstrap-italia/dist/svg/sprite.svg#it-close-circle"></use>
      </svg>
      <h1 class="title-xxxlarge">{{ 'pratica.payment_error' | trans }}</h1>
    </div>
    <p
      class="subtitle-small">{{ 'pratica.payment_pending_error_message'|trans({'%name%':pratica.servizio.name,'%id%':pratica.id})|raw }}</p>
  {% else %}
    <div class="categoryicon-top d-flex">
      <svg class="icon icon-success mr-10 big-lg-icon mb-1" aria-hidden="true">
        <use href="/bootstrap-italia/dist/svg/sprite.svg#it-check-circle"></use>
      </svg>
      <h1 class="title-xxxlarge">
        {{ 'pratica.application_payment_pending' | trans }}
      </h1>
    </div>
    <p class="subtitle-small">{{ 'pratica.payment_status_unknown' | trans }}</p>
  {% endif %}
<p class="mt-4 mb-0">
  {{ 'payment.amount' | trans }}: <strong>{{ pratica.paymentAmount }}
    € {{ 'pratica.payment_transaction_label'|trans }}</strong>
</p>

<p class="mt-4 mt-lg-3 mb-40 mb-lg-80">
  {{ 'pratica.sent_to_summary_with_payment' | trans }}
  <a class="t-primary"
     href="{{ path('pratica_show_detail', {'pratica': pratica.id}) }}">{{ 'personal_area' | trans }}</a> {{ 'pratica.sent_to_summary_payment_pending_or' | trans({'%instance_url%': path('service_access', {'servizio': pratica.servizio.slug}),'%new_request%': 'new_request' | trans}) | raw }}
</p>

templates/Pratiche/parts/landing/_receipt.html.twig
<div>
  {# In attesa di generazione del pdf #}
  {% if pratica.status == 1900 %}
    {% if pratica.servizio.isProtocolRequired %}
      {% set fcqn_parts = pratica.servizio.praticaFCQN | split('\\') %}
      {% set class_name = fcqn_parts|last %}
      <p class="text-center m-0 {{ 'd-none-'~ class_name }}">
        {{ 'operatori.attesa_modulo_compilato_info'|trans|raw }}
      </p>
    {% endif %}
    {# Pratica inviata #}
  {% elseif pratica.status == 2000 %}
    {% if pratica.servizio.receipt == constant('RECEIPT_COMPILED_MODULE_ON_DEMAND', pratica.servizio) %}
      <button id="download_module"
              data-print="{{ path('print_pratiche', {'pratica': pratica})  ~ '?preview=true' }}"
              class="btn btn-outline-primary fw-bold mt-3">
                  <span class="rounded-icon">
                    <svg class="icon icon-primary icon-sm" aria-hidden="true">
                      <use href="/bootstrap-italia/dist/svg/sprite.svg#it-download"></use>
                    </svg>
                  </span>
        <span>{{ 'operatori.scarica_ricevuta'|trans }}</span>
      </button>
    {% else %}
      {% set attachment = pratica.moduliCompilati|first %}
      <a class="btn btn-outline-primary fw-bold mt-3"
         href="{{ path('allegati_download', {'allegato': attachment.id}) }}" download>
                  <span class="rounded-icon">
                    <svg class="icon icon-primary icon-sm" aria-hidden="true">
                      <use href="/bootstrap-italia/dist/svg/sprite.svg#it-download"></use>
                    </svg>
                  </span>
        <span>{{ 'operatori.scarica_ricevuta'|trans }}</span>
      </a>
    {% endif %}
  {% endif %}
</div>